#include "TFile.h"
#include "TRandom.h"
#include "TTree.h"
#include "TSystem.h"
#include "PSimHit.h"
   
void demo3() {
   //create a new ROOT file
   TFile f("demo3.root","recreate");
   
   //Create a ROOT Tree with one single top level branch
   int split = 99;  //you can try split=1 and split=0
   int bufsize = 16000;
   PSimHit *hit = 0;
   TTree T("T","CMS demo tree");
   T.Branch("hit","PSimHit",&hit,bufsize,split);
   
   //Create hits in a loop and fill the Tree
   TRandom r;
   for (int i=0;i<50000;i++) {
      delete hit;
      Local3DPoint pentry(r.Gaus(0,1), r.Gaus(0,1), r.Gaus(0,10));
      Local3DPoint pexit (r.Gaus(0,3), r.Gaus(0,3), r.Gaus(50,20));
      float pabs = 100*r.Rndm();
      float tof  = r.Gaus(1e-6,1e-8);
      float eloss= r.Landau(1e-3,1e-7);
      int ptype  = i%2;
      int detId  = i%20;
      int trackId= i%100;
      hit = new PSimHit(pentry,pexit,pabs,tof,eloss,ptype,detId,trackId);
      
      T.Fill();
   }
   
   T.Print();   //Print Tree statistics
   T.Write();   //Write Tree header to the file
}   
